<?php
/**
 * @package	HikaShop for Joomla!
 * @version	2.6.2
 * @author	hikashop.com
 * @copyright	(C) 2010-2016 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

class Stripe_Subscription extends Stripe_ApiResource
{
  public function instanceUrl()
  {
	$id = $this['id'];
	$customer = $this['customer'];
	if (!$id) {
	  throw new Stripe_InvalidRequestError(
		  "Could not determine which URL to request: " .
		  "class instance has invalid ID: $id",
		  null
	  );
	}
	$id = Stripe_ApiRequestor::utf8($id);
	$customer = Stripe_ApiRequestor::utf8($customer);

	$base = self::classUrl('Stripe_Customer');
	$customerExtn = urlencode($customer);
	$extn = urlencode($id);
	return "$base/$customerExtn/subscriptions/$extn";
  }

  public function cancel($params=null)
  {
	$class = get_class();
	return self::_scopedDelete($class, $params);
  }

  public function save()
  {
	$class = get_class();
	return self::_scopedSave($class);
  }

  public function deleteDiscount()
  {
	$requestor = new Stripe_ApiRequestor($this->_apiKey);
	$url = $this->instanceUrl() . '/discount';
	list($response, $apiKey) = $requestor->request('delete', $url);
	$this->refreshFrom(array('discount' => null), $apiKey, true);
  }
}
